﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.PluginInfrastructure;
using System.IO;
using System.Windows.Forms;

namespace HeuristicLab.Services.Hive.DataAccess {
  [Application("Create Hive-3.4 Database", "Creates new empty Hive Database.", false)]
  class CreateHiveDatabaseApplication : ApplicationBase {

    public override void Run() {
      using (var db = HiveDao.CreateContext()) {
        if (db.DatabaseExists())
          db.DeleteDatabase();
        db.CreateDatabase();
        using (var sr = new StreamReader("../../../../HeuristicLab.Services.Hive.DataAccess/3.4/Tools/prepareHiveDatabase.sql")) {
          var commands = sr.ReadToEnd().Split(new string[] {"GO\r"}, System.StringSplitOptions.RemoveEmptyEntries);
          foreach (var cmd in commands) {
            db.ExecuteCommand(cmd);
          }
        }
      }
      MessageBox.Show("Successfully created HeuristicLab.Hive-3.4 database.");
    }
  }
}
